#Persistent

ParseTimeString(TimeStr)
{
  FoundPos := RegExMatch(TimeStr, "O)^(\d+)$", Match)
  If (FoundPos == 0)
  {
    FoundPos := RegExMatch(TimeStr, "O)^((\d+):)?((\d+):)?(\d+)$", Match)
    If (FoundPos == 0)
    {
      FoundPos := RegExMatch(TimeStr, "O)^((\d+)h)?((\d+)m)?((\d+)s)?$", Match)
      If (FoundPos == 0)
      {
        Return "TimeParseFailure"
      }
      Else
      {
        Hours := Match.Value(2)
        Mins := Match.Value(4)
        Secs := Match.Value(6)
        ; XXX
        OutputDebug, % "Hours: " . Hours
        OutputDebug, % "Mins: " . Mins
        OutputDebug, % "Secs: " . Secs
        Seconds := 0
        If (Hours != "")
        {
          Seconds += Hours * 60 * 60
        }
        If (Mins != "")
        {
          Seconds += Mins * 60
        }
        If (Secs != "")
        {
          Seconds += Secs
        }
      }
    }
    Else
    {
      Left := Match.Value(2)
      Middle := Match.Value(4)
      Right := Match.Value(5)
      ; XXX
      OutputDebug, % "Left: " . Left
      OutputDebug, % "Middle: " . Middle
      OutputDebug, % "Right: " . Right
      ; 3 parts or 2 parts?
      If (Middle == "")
      {
        ; Left represents minutes
        If (Left == "") ; XXX: shouldn't get here because of prev regexp
        {
          OutputDebug, % "Unexpected occurence"
          MsgBox, % "Sorry, unable to handle: " . TimeStr
          ExitApp
        }
        Else
        {
          Seconds := (Left * 60) + Right
        }
      }
      Else
      {
        ; Left represents hours
        Seconds := (Left * 60 * 60) + (Middle * 60) + Right
      }
    }
  }
  Else
  {
    Seconds := Match.Value(1)
  }
  OutputDebug, % "Parsed Seconds Value: " . Seconds
  MSec := Seconds * 1000
  Return MSec
}

Color := "EEAA99"

NArgs = %0%

TimeStr = %1%

MessageStr := "Time is up!"
If (NArgs > 1)
{
  Second = %2%
  If (Second != "")
  {
    MessageStr := Second
  }
}

; XXX
OutputDebug, % "Number of arguments passed in: " . NArgs
OutputDebug, % "  TimeStr: " . TimeStr
OutputDebug, % "  MessageStr: " . MessageStr

Period := ParseTimeString(TimeStr)

OutputDebug, % "Period: " . Period

If Period is not integer
{
  SoundBeep
  MsgBox, % "Sorry, didn't recognize time string: " . TimeStr
  ExitApp
}

; negative value for one time only
Period := -1 * Period
SetTimer, TimeUp, % Period

Return

TimeUp:
{
  ; XXX: leverage Large Type or be self-sufficient?
  ; +ToolWindow avoids a taskbar button and an alt-tab menu item.
  Gui +LastFound +AlwaysOnTop -Caption +ToolWindow  
  Gui, Color, % Color
  Gui, Font, % "s128"
  ; XXX: how to work w/ colors dynamically...cLime seems static...
  Gui, Add, Text, vMyText cLime, % MessageStr
  ; Make all pixels of this color transparent and the text translucent (150)
  WinSet, TransColor, % Color . " " . 150
  ; NoActivate avoids deactivating the currently active window.
  Gui, Show, Center
  SoundBeep
  Return
}

Esc::
{
  ExitApp
}
